{-# LANGUAGE DeriveAnyClass #-}
{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE FlexibleInstances #-}

module DfsekConfig (OIDCConfig (..), DfsekConfig (..), DatabaseConfig (..), widgetFile) where

import ClassyPrelude.Conduit (Generic)
import Data.Aeson
import Data.Text (Text)
import URI.ByteString
import URI.ByteString.Aeson ()
import Language.Haskell.TH.Syntax  (Exp, Q)
import Yesod.Default.Util          (WidgetFileSettings, widgetFileNoReload)
import ClassyPrelude.Yesod (def)
 
data DfsekConfig = DfsekConfig
  { oidc :: OIDCConfig,
    database :: DatabaseConfig,
    host :: Text,
    content_directory :: String,
    well_known_directory :: String
  }
  deriving (Generic, FromJSON)

data DatabaseConfig = DatabaseConfig
  { sqlite_file :: Text,
    connection_count :: Int
  }
  deriving (Generic, FromJSON)

data OIDCConfig = OIDCConfig
  { secret :: Text,
    client_id :: Text,
    token_url :: URIRef Absolute,
    auth_url :: URIRef Absolute,
    user_info :: URIRef Absolute,
    username_attribute :: Text,
    plugin_name :: Text
  }
  deriving (Generic, FromJSON)

widgetFileSettings :: WidgetFileSettings
widgetFileSettings = def

widgetFile :: String -> Q Exp
widgetFile = widgetFileNoReload widgetFileSettings
